import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Projectiles here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Projectiles extends SmoothMover
{
    /**
     * Act - do whatever the Projectiles wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public int damage;
    public Killable target;
    public double speed;
    public Projectiles(Killable target)
    {
        damage = 5;
        speed = 1.2;
        this.target = target;
    }
    public void act() 
    {
        Actor a = ((Actor)target);
        if(a.getWorld() != null)//a is in world(so not dead)
        {
            turnTowards(a.getX(), a.getY());
        }
        else
        {
            getWorld().removeObject(this);
            return;
        }
        move(speed);
        if(getOneIntersectingObject(Units.class) == target)//collide with target, damages target then remove self
        {
            target.takeDamage(damage);
            getWorld().removeObject(this);
            return;
        }
    }
}
